// KIni.cpp: KIni NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "KIni.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

KIni::KIni()
{
	KIni(K_INI);
}

KIni::~KIni()
{

}

KIni::KIni(int nMode,LPCTSTR lpKey,LPCTSTR lpID)
{
	// ܂̓[hۑ
	m_nMode = nMode;

	// Ƀ[hƂ̏
	switch(nMode)
	{
	case K_INI:
		IniInt();
		break;

	case K_REG:
		RegInt(lpKey,lpID);
		break;
	default:
		return;
	}
}

int KIni::IniInt()
{
	// INIt@C[h
	// pX + data.ini𓾂

	// sĂ郂W[̃pX擾
	char chBuf[MAX_PATH+1];
	::GetModuleFileName(NULL,chBuf,MAX_PATH);

	// eɕ
	char szDrive[_MAX_DRIVE + 1] ;	// hCui[̈ 
	char szPath [_MAX_PATH + 1]  ;	// pXi[̈ 
	_splitpath(chBuf,szDrive,szPath,NULL,NULL);

	m_cPath+=szDrive;
	m_cPath+=szPath;
	m_cPath+="data.ini";

	return 0;
}

int KIni::RegInt(LPCTSTR lpKey,LPCTSTR lpID)
{
	// HKEY_CURRENT_USER\Software\Ж\\tg\ۑ
	// ܂͊JׂTuL[̖O
	string cSubkey = "Software\\";
	m_cKey = "Software\\";
	m_cKey += lpKey;
	m_cKey += "\\";
	m_cKey += lpID;

	return 0;
}

int KIni::RegClose()
{
	//return ::RegCloseKey(m_hKey);
	return 0;
}

int KIni::IniClose()
{
	return 0;
}

string KIni::GetProfile(LPCTSTR lpSection, LPCTSTR lpEntry)
{
	if(m_nMode == K_INI)
	{
		return IniGetProfile(lpSection,lpEntry);
	}
	else if(m_nMode == K_REG)
	{
		return RegGetProfile(lpSection,lpEntry);
	}
	return "";
}

string KIni::IniGetProfile(LPCTSTR lpSection, LPCTSTR lpEntry)
{
	string cBuf;
	char chBuf[MAX_PATH+1];

	::GetPrivateProfileString(lpSection,lpEntry,NULL,chBuf,MAX_PATH,m_cPath.c_str());
	cBuf = chBuf;
	return cBuf;
}

string KIni::RegGetProfile(LPCTSTR lpSection, LPCTSTR lpEntry)
{
	// ܂͎w肳ꂽZNVJ
	HKEY hKey = RegOpen(lpSection);

	// ǂ݂Ƃ

	// ܂̓TCY擾
	DWORD dwType,dwSize;
	::RegQueryValueEx(hKey,lpEntry,0,
		&dwType,NULL,&dwSize);

	// zgɓǂ݂Ƃ
	BYTE  *pData;
	pData = new BYTE[dwSize];
	::RegQueryValueEx(hKey,lpEntry,0,
		&dwType,pData,&dwSize);

	string cBuffer;
	cBuffer = (const char*)pData;
	delete [] pData;

	// ŌɃZNV
	RegClose(&hKey);


	return cBuffer;
}

int KIni::WriteProfile(LPCTSTR lpSection, LPCTSTR lpEntry, LPCTSTR lpValue)
{
	if(m_nMode == K_INI)
	{
		return IniWriteProfile(lpSection,lpEntry,lpValue);
	}
	else if(m_nMode == K_REG)
	{
		return RegWriteProfile(lpSection,lpEntry,lpValue);
	}
	return -1;	
}

int KIni::IniWriteProfile(LPCTSTR lpSection, LPCTSTR lpEntry, LPCTSTR lpValue)
{
	if(WritePrivateProfileString(lpSection,lpEntry,lpValue,m_cPath.c_str())==TRUE)
	{
		return 0;
	}else{
		return -1;
	}
	//return 0;
}

int KIni::RegWriteProfile(LPCTSTR lpSection, LPCTSTR lpEntry, LPCTSTR lpValue)
{
	HKEY hKey = RegOpen(lpSection);
	int nRes =  ::RegSetValueEx(hKey,lpEntry,0,REG_SZ,
		(CONST BYTE*)lpValue,strlen(lpValue));


	RegClose(&hKey);
	return nRes;
}

HKEY KIni::RegOpen(LPCTSTR lpSection)
{
	// HKEY_CURRENT_USER\Software\Ж\\tg\ۑ
	// ܂͊JׂTuL[̖O
	string cSubkey;
	cSubkey = m_cKey + "\\";
	cSubkey += lpSection;

	// ĊJ
	HKEY hKey;
	DWORD dwRes;
	RegCreateKeyEx(HKEY_CURRENT_USER,cSubkey.c_str(),0,NULL,REG_OPTION_NON_VOLATILE,
					KEY_ALL_ACCESS,NULL,&hKey,&dwRes);

	return hKey;
}

int KIni::RegClose(HKEY *pKey)
{
	return RegCloseKey(*pKey);
}
